<html>
<head>
<title>OGRE: OgreSceneNode.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreSceneNode.h</h1><a href="OgreSceneNode_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef _SceneNode_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define _SceneNode_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreNode_8h.html">OgreNode.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgreAxisAlignedBox_8h.html">OgreAxisAlignedBox.h</a>"</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 
<a name="l00040"></a>00040     <span class="comment">// forward decl</span>
<a name="l00041"></a>00041     <span class="keyword">struct </span>VisibleObjectsBoundsInfo;
<a name="l00042"></a>00042 
<a name="l00052"></a><a class="code" href="classOgre_1_1SceneNode.html">00052</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>
<a name="l00053"></a>00053     {
<a name="l00054"></a>00054     <span class="keyword">public</span>:
<a name="l00055"></a><a class="code" href="classOgre_1_1SceneNode.html#49043fde03f6003b0cfe1a65f2ff64df">00055</a>         <span class="keyword">typedef</span> HashMap&lt;String, MovableObject*&gt; ObjectMap;
<a name="l00056"></a><a class="code" href="classOgre_1_1SceneNode.html#0e2fa88602b6dedc628b66246c1469c9">00056</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">MapIterator&lt;ObjectMap&gt;</a> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">ObjectIterator</a>;
<a name="l00057"></a><a class="code" href="classOgre_1_1SceneNode.html#87b7fca094d8a66c3a2651916197d052">00057</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Wraps iteration over a const map.">ConstMapIterator&lt;ObjectMap&gt;</a> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Wraps iteration over a const map.">ConstObjectIterator</a>;
<a name="l00058"></a>00058 
<a name="l00059"></a>00059     <span class="keyword">protected</span>:
<a name="l00060"></a><a class="code" href="classOgre_1_1SceneNode.html#92ed6ce65738128bee3cfcbb9074dab7">00060</a>         ObjectMap mObjectsByName;
<a name="l00061"></a>00061 
<a name="l00063"></a><a class="code" href="classOgre_1_1SceneNode.html#b63dc19d99002d2634db61fdfb2042bc">00063</a>         <a class="code" href="classOgre_1_1WireBoundingBox.html" title="Allows the rendering of a wireframe bounding box.">WireBoundingBox</a> *mWireBoundingBox;
<a name="l00065"></a><a class="code" href="classOgre_1_1SceneNode.html#2a23d7a4772313b1d4568b946dfe23a0">00065</a>         <span class="keywordtype">bool</span> mShowBoundingBox;
<a name="l00066"></a>00066 
<a name="l00068"></a><a class="code" href="classOgre_1_1SceneNode.html#3ed43b1903a0255a82ee41571b3ac108">00068</a>         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* mCreator;
<a name="l00069"></a>00069 
<a name="l00071"></a><a class="code" href="classOgre_1_1SceneNode.html#ae5a245a9ef39e8a32f15360b7404d92">00071</a>         <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> mWorldAABB;
<a name="l00072"></a>00072 
<a name="l00074"></a>00074         <span class="keywordtype">void</span> updateFromParentImpl(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00075"></a>00075 
<a name="l00077"></a>00077         <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* createChildImpl(<span class="keywordtype">void</span>);
<a name="l00078"></a>00078 
<a name="l00080"></a>00080         <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* createChildImpl(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00081"></a>00081 
<a name="l00083"></a>00083         <span class="keywordtype">void</span> setParent(<a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* parent);
<a name="l00084"></a>00084 
<a name="l00088"></a>00088         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setInSceneGraph(<span class="keywordtype">bool</span> inGraph);
<a name="l00089"></a>00089 
<a name="l00091"></a><a class="code" href="classOgre_1_1SceneNode.html#79fe2c7ff9599191a58902cdae1b3a3f">00091</a>         <span class="keywordtype">bool</span> mYawFixed;
<a name="l00093"></a><a class="code" href="classOgre_1_1SceneNode.html#37db788390eb6da498e0e4bfeb2400e1">00093</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> mYawFixedAxis;
<a name="l00094"></a>00094 
<a name="l00096"></a><a class="code" href="classOgre_1_1SceneNode.html#d5ab7b1d824dc3be02e1f116d0801b40">00096</a>         <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>* mAutoTrackTarget;
<a name="l00098"></a><a class="code" href="classOgre_1_1SceneNode.html#79a962278ebfd05a0371659f0915650e">00098</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> mAutoTrackOffset;
<a name="l00100"></a><a class="code" href="classOgre_1_1SceneNode.html#3718047a30a7575e283604ae27bdc31b">00100</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> mAutoTrackLocalDirection;
<a name="l00102"></a><a class="code" href="classOgre_1_1SceneNode.html#bde5946531210225faafcf92b7eb4660">00102</a>         <span class="keywordtype">bool</span> mIsInSceneGraph;
<a name="l00103"></a>00103     <span class="keyword">public</span>:
<a name="l00108"></a>00108         <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* creator);
<a name="l00113"></a>00113         <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00114"></a>00114         ~<a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>();
<a name="l00115"></a>00115 
<a name="l00121"></a>00121         <span class="keyword">virtual</span> <span class="keywordtype">void</span> attachObject(<a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class definining a movable object in a scene.">MovableObject</a>* obj);
<a name="l00122"></a>00122 
<a name="l00125"></a>00125         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> numAttachedObjects(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00126"></a>00126 
<a name="l00131"></a>00131         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class definining a movable object in a scene.">MovableObject</a>* getAttachedObject(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l00132"></a>00132 
<a name="l00136"></a>00136         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class definining a movable object in a scene.">MovableObject</a>* getAttachedObject(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00137"></a>00137 
<a name="l00143"></a>00143         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class definining a movable object in a scene.">MovableObject</a>* detachObject(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l00145"></a>00145         <span class="keyword">virtual</span> <span class="keywordtype">void</span> detachObject(<a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class definining a movable object in a scene.">MovableObject</a>* obj);
<a name="l00146"></a>00146 
<a name="l00148"></a>00148         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class definining a movable object in a scene.">MovableObject</a>* detachObject(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00149"></a>00149 
<a name="l00152"></a>00152         <span class="keyword">virtual</span> <span class="keywordtype">void</span> detachAllObjects(<span class="keywordtype">void</span>);
<a name="l00153"></a>00153 
<a name="l00157"></a><a class="code" href="classOgre_1_1SceneNode.html#4e8a3cc40a8b7cac0ea3dd761e51beca">00157</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isInSceneGraph(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIsInSceneGraph; }
<a name="l00158"></a>00158 
<a name="l00163"></a><a class="code" href="classOgre_1_1SceneNode.html#f0481ea7c8fb0c5e8a9422dc7ecb60a8">00163</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyRootNode(<span class="keywordtype">void</span>) { mIsInSceneGraph = <span class="keyword">true</span>; }
<a name="l00164"></a>00164             
<a name="l00165"></a>00165 
<a name="l00178"></a>00178         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _update(<span class="keywordtype">bool</span> updateChildren, <span class="keywordtype">bool</span> parentHasChanged);
<a name="l00179"></a>00179 
<a name="l00182"></a>00182         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateBounds(<span class="keywordtype">void</span>);
<a name="l00183"></a>00183 
<a name="l00202"></a>00202         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _findVisibleObjects(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam, <a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue, 
<a name="l00203"></a>00203             <a class="code" href="structOgre_1_1VisibleObjectsBoundsInfo.html" title="Structure collecting together information about the visible objects that have been...">VisibleObjectsBoundsInfo</a>* visibleBounds, 
<a name="l00204"></a>00204             <span class="keywordtype">bool</span> includeChildren = <span class="keyword">true</span>, <span class="keywordtype">bool</span> displayNodes = <span class="keyword">false</span>, <span class="keywordtype">bool</span> onlyShadowCasters = <span class="keyword">false</span>);
<a name="l00205"></a>00205 
<a name="l00211"></a>00211         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; _getWorldAABB(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00212"></a>00212 
<a name="l00223"></a>00223         <span class="keyword">virtual</span> ObjectIterator getAttachedObjectIterator(<span class="keywordtype">void</span>);
<a name="l00234"></a>00234         <span class="keyword">virtual</span> ConstObjectIterator getAttachedObjectIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00235"></a>00235 
<a name="l00241"></a><a class="code" href="classOgre_1_1SceneNode.html#e17ea5739bf85c988cb21d0df298976f">00241</a>         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* getCreator(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mCreator; }
<a name="l00242"></a>00242 
<a name="l00253"></a>00253         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAndDestroyChild(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00254"></a>00254 
<a name="l00265"></a>00265         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAndDestroyChild(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index);
<a name="l00266"></a>00266 
<a name="l00273"></a>00273         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAndDestroyAllChildren(<span class="keywordtype">void</span>);
<a name="l00274"></a>00274 
<a name="l00279"></a>00279         <span class="keyword">virtual</span> <span class="keywordtype">void</span> showBoundingBox(<span class="keywordtype">bool</span> bShow);
<a name="l00280"></a>00280 
<a name="l00283"></a>00283         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _addBoundingBoxToQueue(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue);
<a name="l00284"></a>00284 
<a name="l00292"></a>00292         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getShowBoundingBox() <span class="keyword">const</span>;
<a name="l00293"></a>00293 
<a name="l00300"></a>00300         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>* createChildSceneNode(
<a name="l00301"></a>00301             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; translate = <a class="code" href="classOgre_1_1Vector3.html#5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>, 
<a name="l00302"></a>00302             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rotate = <a class="code" href="classOgre_1_1Quaternion.html#441b8d52549e1dedec27420325a313ef">Quaternion::IDENTITY</a> );
<a name="l00303"></a>00303 
<a name="l00313"></a>00313         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>* createChildSceneNode(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; translate = <a class="code" href="classOgre_1_1Vector3.html#5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rotate = <a class="code" href="classOgre_1_1Quaternion.html#441b8d52549e1dedec27420325a313ef">Quaternion::IDENTITY</a>);
<a name="l00314"></a>00314 
<a name="l00330"></a>00330         <span class="keyword">virtual</span> <span class="keywordtype">void</span> findLights(<a class="code" href="namespaceOgre.html#b82c6299605910b4051ebb3cc3e5539e">LightList</a>&amp; destList, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> radius) <span class="keyword">const</span>;
<a name="l00331"></a>00331 
<a name="l00346"></a>00346         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setFixedYawAxis( <span class="keywordtype">bool</span> useFixed, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; fixedAxis = <a class="code" href="classOgre_1_1Vector3.html#8d1a1f7af535bcc8d9c78b1732bc1b90">Vector3::UNIT_Y</a> );
<a name="l00347"></a>00347 
<a name="l00350"></a>00350         <span class="keyword">virtual</span> <span class="keywordtype">void</span> yaw(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; angle, TransformSpace relativeTo = TS_LOCAL);
<a name="l00351"></a>00351 <span class="preprocessor">#ifndef OGRE_FORCE_ANGLE_TYPES</span>
<a name="l00352"></a>00352 <span class="preprocessor"></span>        <span class="keyword">inline</span> <span class="keywordtype">void</span> yaw(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> degrees, TransformSpace relativeTo = TS_LOCAL) {
<a name="l00353"></a>00353             yaw ( <a class="code" href="classOgre_1_1Angle.html" title="Wrapper class which identifies a value as the currently default angle type, as defined...">Angle</a>(degrees), relativeTo );
<a name="l00354"></a>00354         }
<a name="l00355"></a>00355 <span class="preprocessor">#endif//OGRE_FORCE_ANGLE_TYPES</span>
<a name="l00356"></a>00356 <span class="preprocessor"></span>
<a name="l00366"></a>00366         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setDirection(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> y, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> z, 
<a name="l00367"></a>00367             TransformSpace relativeTo = TS_LOCAL, 
<a name="l00368"></a>00368             <span class="keyword">const</span> Vector3&amp; localDirectionVector = <a class="code" href="classOgre_1_1Vector3.html#bdeebea4e94e114215a51831f9792f19">Vector3::NEGATIVE_UNIT_Z</a>);
<a name="l00369"></a>00369 
<a name="l00380"></a>00380         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setDirection(<span class="keyword">const</span> Vector3&amp; vec, TransformSpace relativeTo = TS_LOCAL, 
<a name="l00381"></a>00381             <span class="keyword">const</span> Vector3&amp; localDirectionVector = <a class="code" href="classOgre_1_1Vector3.html#bdeebea4e94e114215a51831f9792f19">Vector3::NEGATIVE_UNIT_Z</a>);
<a name="l00388"></a>00388         <span class="keyword">virtual</span> <span class="keywordtype">void</span> lookAt( <span class="keyword">const</span> Vector3&amp; targetPoint, TransformSpace relativeTo,
<a name="l00389"></a>00389             <span class="keyword">const</span> Vector3&amp; localDirectionVector = <a class="code" href="classOgre_1_1Vector3.html#bdeebea4e94e114215a51831f9792f19">Vector3::NEGATIVE_UNIT_Z</a>);
<a name="l00408"></a>00408         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setAutoTracking(<span class="keywordtype">bool</span> enabled, SceneNode* target = 0, 
<a name="l00409"></a>00409             <span class="keyword">const</span> Vector3&amp; localDirectionVector = <a class="code" href="classOgre_1_1Vector3.html#bdeebea4e94e114215a51831f9792f19">Vector3::NEGATIVE_UNIT_Z</a>,
<a name="l00410"></a>00410             <span class="keyword">const</span> Vector3&amp; offset = <a class="code" href="classOgre_1_1Vector3.html#5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>);
<a name="l00412"></a><a class="code" href="classOgre_1_1SceneNode.html#9f25ff62bc7c5f3573872d1937edd35b">00412</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>* getAutoTrackTarget(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mAutoTrackTarget; }
<a name="l00414"></a><a class="code" href="classOgre_1_1SceneNode.html#3bfbb62bc1e7879e3ed8efab74ff1449">00414</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getAutoTrackOffset(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mAutoTrackOffset; }
<a name="l00416"></a><a class="code" href="classOgre_1_1SceneNode.html#1c7da5149270d58781185d6c94c90cf3">00416</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getAutoTrackLocalDirection(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mAutoTrackLocalDirection; }
<a name="l00418"></a>00418         <span class="keywordtype">void</span> _autoTrack(<span class="keywordtype">void</span>);
<a name="l00420"></a>00420         <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>* getParentSceneNode(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00429"></a>00429         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setVisible(<span class="keywordtype">bool</span> visible, <span class="keywordtype">bool</span> cascade = <span class="keyword">true</span>);
<a name="l00437"></a>00437         <span class="keyword">virtual</span> <span class="keywordtype">void</span> flipVisibility(<span class="keywordtype">bool</span> cascade = <span class="keyword">true</span>);
<a name="l00438"></a>00438 
<a name="l00439"></a>00439 
<a name="l00440"></a>00440 
<a name="l00441"></a>00441 
<a name="l00442"></a>00442 
<a name="l00443"></a>00443     };
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 
<a name="l00446"></a>00446 }<span class="comment">// namespace</span>
<a name="l00447"></a>00447 
<a name="l00448"></a>00448 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:56 2008
</p>
</body>
</html>
